/*
 *
 *  Copyright (c) 2010 Steve Slaven
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
*/
package net.hoopajoo.android.SoftKeys;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;

// this is just a stub to handle intent calls
public class SendInput extends Activity {
    public static String ACTION_CODE = "net.hoopajoo.android.SoftKeys.KEY_CODE";

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        onNewIntent( getIntent() );
    }
    
    @Override
    public void onNewIntent( Intent i ) {
        Globals app = (Globals)getApplication();
        
        String action = i.getAction();
        int keyid = 0;
        if( action.equals(  ACTION_CODE ) ) {
            // by key name?
            Bundle e = i.getExtras();
            boolean longClick = e.getBoolean( "longclick", false );
            if( e.getString( "keyname" ) != null ) {
                String key = e.getString( "keyname" );
                //Log.d( "SoftKeys.SendInput", "resolving: " + key );
                if( key.equals( "home" ) ) {
                    app.doHomeAction( longClick );
                    this.finish();
                    return;
                }else{
                    // run through resolver
                    keyid = K.keyNameToId( key );
                }
            }else if( e.getInt( "keyid", 0 ) != 0 ) {
                keyid = e.getInt( "keyid", 0 );
            }
        }

        app.sendKeys( new int[] { keyid } );
        
        this.finish();
    }
}
